package cn.cslg.report.service.impl;

import cn.cslg.report.entity.AssoProductFile;
import cn.cslg.report.mapper.AssoProductFileMapper;
import cn.cslg.report.service.IAssoProductFileService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 产品文件关联的Service层实现类
 *
 * @Author chenyu
 * @Data 2022/12/20
 */
@Service
@RequiredArgsConstructor
public class AssoProductFileServiceImpl implements IAssoProductFileService {
    private final AssoProductFileMapper assoProductFileMapper;

    /**
     * 新增产品文件关联数据
     *
     * @param productId 产品id
     * @param fileIds   附件id
     */
    @Override
    public void addAsso(Integer productId, List<Integer> fileIds) {
        List<AssoProductFile> list = new ArrayList<>();
        for (Integer fileId : fileIds) {
            AssoProductFile assoProductFile = new AssoProductFile()
                    .setProductId(productId)
                    .setFileId(fileId)
                    .setFileUseType(0);
            list.add(assoProductFile);
        }
        assoProductFileMapper.insertBatch(list);
    }

    /**
     * 根据附件fileId删除产品文件关联数据
     *
     * @param fileIds 附件id集合
     */
    @Override
    public void deleteAssoByFileIds(List<Integer> fileIds) {
        if (fileIds != null) {
            assoProductFileMapper.deleteByFileIds(fileIds);
        }
    }

    /**
     * 根据产品productId删除产品文件关联数据
     *
     * @param productId 产品id
     */
    @Override
    public void deleteAssoByProductId(Integer productId) {
        if (productId != null) {
            assoProductFileMapper.deleteByProductId(productId);
        }
    }


}
